=== debian/changelog ===
hipsolver (6.4.1-1~exp1) experimental; urgency=medium

  * set watch file for 6.4.x
  * New upstream version 6.4.1
  * Remove patches
  * Add libhipsparse-dev dependancy
  * Use rocm-doc-build for doc
  * Add deps on librocsparse-dev and hipcc
  * Add deps on libsuitesparse-dev and libcholmod5
  * Fix double-def in compile
  * Install test dir
  * Add myself in uploaders
  * Let dephelper generate symbols
  * Set Standards-Version to 4.7.2

 -- Christian Bayle <bayle@debian.org>  Mon, 29 Sep 2025 23:39:33 +0200
