=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export VERBOSE=1

CMAKE_FLAGS = \
	-DCMAKE_BUILD_TYPE=Release \
	-DROCM_SYMLINK_LIBS=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF \
	-DHIPSOLVER_FIND_PACKAGE_LAPACK_CONFIG=OFF \
	-DBUILD_HIPSPARSE_TESTS=OFF \
	-DBUILD_WITH_SPARSE=ON \
	-DBUILD_CLIENTS_BENCHMARKS=ON \
	-DBUILD_CLIENTS_TESTS=ON \
	-DHIP_PLATFORM=$(shell hipconfig --platform) \


ifeq (,$(filter nocheck,$(DEB_BUILD_PROFILES)))
CMAKE_FLAGS += -DBUILD_CLIENTS_TESTS=ON
endif

# From TheRock
# -DCMAKE_BUILD_TYPE=Release 
# -DHIP_PLATFORM=amd 
# -DROCM_PATH= 
# -DROCM_DIR= 
# -DBUILD_HIPSPARSE_TESTS=OFF 
# -DBUILD_WITH_SPARSE=ON 
# -DBUILD_CLIENTS_BENCHMARKS=ON 
# -DBUILD_CLIENTS_TESTS=ON 
# -DHIPSOLVER_FIND_PACKAGE_LAPACK_CONFIG=OFF

%:
	dh $@ -Scmake

override_dh_auto_configure-arch:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	set -e \
	; if [ -r /dev/kfd ] \
	; then obj-$(DEB_HOST_MULTIARCH)/clients/staging/hipsolver-test \
	; else echo "W: /dev/kfd unreadable: no available AMD GPU." \
	;      echo "W: tests skipped." \
	; fi
endif

override_dh_auto_configure-indep:
	:

override_dh_auto_build-indep:
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	rocm-docs-build
	rm -rf build/html/_static/fonts
	rm -rf build/html/_static/vendor
endif

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:
