=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/libhipsolver0-tests/hipsolver-test --gtest_output=xml:${AUTOPKGTEST_ARTIFACTS}/
Features: test-name=libhipsolver0-tests
Depends: pkg-rocm-tools, libhipsolver0-tests, libopenblas0-pthread
Restrictions: skippable, allow-stderr
Architecture: amd64
