=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%hipsolver-$1.tar.gz%" \
    https://github.com/rocm/hipsolver/tags?after=rocm-7.0.0 \
    (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
